# coding: utf-8
"""
Script for configuration files initialization after module installation.
"""

import os

from tionix_client.cmd.configure import process_dir, ConfigureException

from tionix_scheduler_client.core import BASE_DIR
from tionix_scheduler_client.core.i18n import ugettext as _


CONF_DIR = os.path.join(BASE_DIR, 'conf')


def configure(verbose=False):
    try:
        process_dir(CONF_DIR)
    except ConfigureException as err:
        result = os.EX_SOFTWARE, err.message
    except Exception as ex:
        if verbose:
            msg = _(u'Error while configuring module: {0}').format(unicode(ex))
        else:
            msg = _(u'Unknown error. Please contact your administrator.')
        result = os.EX_SOFTWARE, msg
    else:
        result = os.EX_OK, u''

    return result
