# coding: utf-8


class ObjectGroupEnum(object):

    admin = 'admin'
    vdi = 'vdi'
    project = 'project'
    identity = 'identity'

    groups = (
        admin,
        vdi,
        project,
        identity
    )


class ObjectTypeEnum(object):
    hypervisor = 'hypervisor'
    instance = 'instance'
    volume = 'volume'
    project = 'project'

    types = (
        hypervisor,
        instance,
        volume,
        project
    )

    VERBOSE_NAMES = {
        hypervisor: 'Hypervisor',
        instance: 'Instance',
        volume: 'Volume',
        project: 'Project'
    }


TASK_INTERVAL_RANGE = (1, 31)


class ActionFieldsEnum(object):

    REBUILD = 'rebuild_vm'
    SHUTDOWN = 'shutdown_host'
    LAUNCH_BASE_VM = 'launch_base_vm'
    LAUNCH_VDI_VM = 'launch_vdi_vm'
    LAUNCH_VM = 'launch_vm'

    fields = {
        REBUILD: ('image', 'password', 'disk_config'),
        SHUTDOWN: ('allow_off_vm', 'allow_evacuate'),
        LAUNCH_BASE_VM: ('name', 'image', 'network_id', 'flavor_id', 'count'),
        LAUNCH_VDI_VM: ('name', 'count'),
        LAUNCH_VM: ('description', 'availability_zone', 'count', 'image_id',
                    'flavor_id', 'networks')
    }


class TaskResultEnum(object):

    task_unknown = 'unknown'
    task_success = 'success'
    task_failure = 'failure'

    VERBOSE_NAMES = {
        task_unknown: 'Success',
        task_success: 'Failure',
        task_failure: 'Unknown',
    }
