import unittest

from tionix_scheduler_client.settings_handler import merge_dicts


class TestSettingsHandler(unittest.TestCase):

    def test_merge_dicts(self):
        base_dict = {}
        update_dict = {}

        self.assertEqual(merge_dicts(base_dict, update_dict), base_dict)

        base_dict = {'key_1': {'key_2': 'value_2'}}
        update_dict = {}

        self.assertEqual(merge_dicts(base_dict, update_dict), base_dict)

        base_dict = {}
        update_dict = {'key_1': {'key_2': 'value_2'}}

        self.assertEqual(merge_dicts(base_dict, update_dict), update_dict)

        base_dict = {'key_1': '1'}
        update_dict = {'key_1': {'key_2': 'value_2'}}

        self.assertEqual(merge_dicts(base_dict, update_dict), update_dict)

        base_dict = {'key_1': {'key_2': 'value_2'}}
        update_dict = {'key_1': 'value_1'}

        self.assertEqual(merge_dicts(base_dict, update_dict), update_dict)

        base_dict = {'key_2': 'value_2'}
        update_dict = {'key_1': {'key_2': 'value_2'}}
        after_merge_dict = {'key_1': {'key_2': 'value_2'}, 'key_2': 'value_2'}

        self.assertEqual(merge_dicts(base_dict, update_dict), after_merge_dict)

        base_dict = {'key_1': {'key_1': 'value_1'}}
        update_dict = {'key_1': {'key_2': 'value_2'}}
        after_merge_dict = {'key_1': {'key_1': 'value_1', 'key_2': 'value_2'}}

        self.assertEqual(merge_dicts(base_dict, update_dict), after_merge_dict)

        base_dict = {
            'key_1': {'key_2': {'key_3': 'value_3', 'key_4': 'value_4'}}}
        update_dict = {
            'key_1': {'key_2': {'key_3': 'new_value_3'}, 'key_3': 'value_3'}}
        after_merge_dict = {
            'key_1': {'key_2': {'key_3': 'new_value_3', 'key_4': 'value_4'},
                      'key_3': 'value_3'}}

        self.assertEqual(merge_dicts(base_dict, update_dict), after_merge_dict)
